package cn.dg32z.lon.commands.sub;

import cn.dg32z.libs.chengzhiya.task.mhdfscheduler.scheduler.MHDFScheduler;
import cn.dg32z.libs.org.jetbrains.annotations.NotNull;
import cn.dg32z.lon.LonAntiCheat;
import cn.dg32z.lon.PluginLoader;
import cn.dg32z.lon.commands.AbstractCommand;
import cn.dg32z.lon.manager.DebugManager;
import com.google.common.base.Charsets;
import com.google.gson.Gson;
import com.google.gson.JsonObject;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import org.bukkit.command.CommandSender;
import org.bukkit.util.StringUtil;

/* loaded from: cn_dg32z_lon_commands_sub.jar:cn/dg32z/lon/commands/sub/Log.class */
public final class Log extends AbstractCommand {
    public Log() {
        super("Upload a log by flag ID", "lonac.commands.log", false);
    }

    public void execute(@NotNull CommandSender sender, @NotNull String label, @NotNull String[] args) {
        if (args.length < 1) {
            sender.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n("commands.prediciton-logs.usage"));
            return;
        }
        try {
            int flagId = Integer.parseInt(args[0]);
            StringBuilder flagData = DebugManager.getFlag(flagId);
            if (flagData == null) {
                sender.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n("commands.prediciton-logs.not-found").replace("%flagId%", String.valueOf(flagId)));
                return;
            }
            String logContent = flagData.toString();
            sender.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n("commands.prediciton-logs.uploading"));
            MHDFScheduler.getAsyncScheduler().runTask(LonAntiCheat.getInstance(), dump -> {
                String url = uploadPaste(logContent);
                if (url != null) {
                    sender.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n("commands.prediciton-logs.uploadded").replace("%url%", url));
                } else {
                    sender.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n("commands.prediciton-logs.uploadfail"));
                }
            });
        } catch (NumberFormatException e) {
            sender.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n("commands.prediciton-logs.invalid"));
        }
    }

    public List<String> tabCompleter(@NotNull CommandSender sender, @NotNull String label, @NotNull String[] args) {
        List<String> completions = new ArrayList<>();
        if (args.length == 1) {
            for (Integer id : DebugManager.flags.keySet()) {
                String flag = id.toString();
                if (StringUtil.startsWithIgnoreCase(flag, args[0])) {
                    completions.add(flag);
                }
            }
        }
        return completions;
    }

    public String uploadPaste(String contents) {
        String contents2 = contents.replace("§c", "").replace("§7", "").replace("§6§l", "").replace("§a", "");
        try {
            HttpURLConnection connection = (HttpURLConnection) new URL("https://paste.md-5.net/documents").openConnection();
            connection.setRequestMethod("POST");
            connection.setDoInput(true);
            connection.setDoOutput(true);
            connection.setRequestProperty("User-Agent", "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.11 (KHTML, like Gecko) Chrome/23.0.1271.95 Safari/537.11");
            OutputStream os = connection.getOutputStream();
            try {
                os.write(contents2.getBytes(Charsets.UTF_8));
                if (os != null) {
                    os.close();
                }
                Gson gson = new Gson();
                JsonObject object = (JsonObject) gson.fromJson(new InputStreamReader(connection.getInputStream(), Charsets.UTF_8), JsonObject.class);
                String pasteUrl = "https://paste.md-5.net/" + object.get("key").getAsString();
                connection.disconnect();
                return pasteUrl;
            } finally {
            }
        } catch (Exception e) {
            return null;
        }
    }
}
